<template>
  <div>
    <h5 v-if="!code && !user.stripe_user_id" class="mb-2">
      Looks like you didn't connect your billing account yet...
    </h5>
    <h4 v-else>
      Stripe integrated
    </h4>
    <v-btn
      v-if="(!code && !user.stripe_user_id) || stripeConnectError"
      elevation="0"
      color="primary"
      :href="stripeConnectURI"
    >
      Connect to stripe
    </v-btn>
    <p v-if="stripeConnectError" class="pt-2 caption red--text text--lighten-1">
      <v-icon class="mr-1 red--text text--lighten-1" small
        >mdi-alert-circle-outline</v-icon
      >
      There was a problem connect stripe to your account, please try again.
    </p>
    <h5 v-if="code && !stripeConnectError" class="mb-2">
      <v-icon>mdi-party-popper</v-icon>
      You're all set with stripe, start charging your client for your online
      services.
    </h5>
  </div>
</template>

<script>
import { mapState } from 'vuex'

export default {
  name: 'StripeConnectButton',
  components: {},
  data: () => ({}),
  computed: {
    ...mapState('authentication', ['user']),
    ...mapState('facilitator', ['code', 'stripeConnectError']),
    stripeConnectURI() {
      // TODO remove hard coded id
      const stripeClientId = 'ca_HH019Ily9APJoHc0Ravnzo5Xr6pXyfWD'
      const { origin } = window.location
      const { uid, email } = this.user
      return `https://connect.stripe.com/express/oauth/authorize?
			&redirect_uri=${origin}/facilitator?type=stripe&client_id=${stripeClientId}&state=${uid}&stripe_user[business_type]=individual
			&stripe_user[email]=${email}`
    }
  },
  mounted() {
    if (this.$route.query.code) {
      const stripeAuthCode = this.$route.query.code
      this.$store.commit('facilitator/setStripeConnectCode', stripeAuthCode)
      this.$store.dispatch('facilitator/stripeConnect', {
        code: stripeAuthCode
      })
      this.$router.push({ path: '/facilitator' })
    }
  },
  destroyed() {
    this.$store.commit('facilitator/setStripeConnectError', null)
  },
  created() {}
}
</script>
